unit General;

{ Network Drawing program }

{ By Phil Marty <phmarty@yahoo.fr> }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{
General functions
}

interface

uses
   Forms,
   SysUtils,
   Dialogs;

type
  TLigInteger=array[0..999999] of Integer;
  PLigInteger=^TLigInteger;

  TLigDouble=array[0..999999] of Double;
  PLigDouble=^TLigDouble;
  TMatDouble=array[0..999999] of PLigDouble;
  PMatDouble=^TMatDouble;

procedure GetmemMat(var MatDouble:PMatDouble;
                    Sx,Sy:Integer);
procedure FreememMat(var MatDouble:PMatDouble;
                     Sx,Sy:Integer);

procedure MySleep(Temps:Integer);
function MyStrToFloat(Line:string):Double;


implementation

procedure GetmemMat(var MatDouble:PMatDouble;
                    Sx,Sy:Integer);
var
   j:Integer;
begin
Getmem(MatDouble,Sy*4);
for j:=0 to Sy-1 do
   begin
   Getmem(MatDouble^[j],Sx*8);
   FillChar(MatDouble^[j]^,Sx*8,0);
   end;
end;

procedure FreememMat(var MatDouble:PMatDouble;
                     Sx,Sy:Integer);
var
   j:Integer;
begin
for j:=0 to Sy-1 do Freemem(MatDouble^[j],Sx*8);
Freemem(MatDouble,Sy*4);
end;

// Cool wait in ms
procedure MySleep(Temps:Integer);
var
   TimeInit:TDateTime;
begin
TimeInit:=Time;
while Time<TimeInit+Temps/1000/60/60/24 do Application.ProcessMessages;
end;

// To be sure to allways correctly handle french format
function MyStrToFloat(Line:string):Double;
begin
    try
    // 0,00
    if (DecimalSeparator=',') and (Pos('.',Line)<>0) then Line[Pos('.',Line)]:=','
    // 0.00
    else if (DecimalSeparator='.') and (Pos(',',Line)<>0) then Line[Pos(',',Line)]:='.'
    // 0
    else if Pos(Decimalseparator,Line)=0 then Line:=Line+DecimalSeparator+'0';

    Result:=StrToFloat(Line);
    except
    ShowMessage('Conversion error of : '+Line);
    end;
end;

end.
