unit MyMath;

{ Network Drawing program }

{ By Phil Marty <phmarty@yahoo.fr> }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{
Math functions
}

interface

uses General;

function GaussJordan(var a:PMatDouble; n:Integer; var b:PMatDouble; m:Integer):Boolean;

implementation

function GaussJordan(var a:PMatDouble; n:Integer; var b:PMatDouble; m:Integer):Boolean;
var
big,dum,pivinv:Double;
i,icol,irow,j,k,l,ll:Integer;
indxc,indxr,ipiv:PLigInteger;
begin
Getmem(indxc,n*8);
Getmem(indxr,n*8);
Getmem(ipiv,n*8);
Result:=True;
for j:=0 to n-1 do ipiv^[j]:=0;
for i:=0 to n-1 do
   begin
   big:=0;
   for j:=0 to n-1 do
      if ipiv[j]<>1 then
         for k:=0 to n-1 do
            if ipiv^[k]=0 then
               if abs(a^[j]^[k])>=big then
                  begin
                  big:=abs(a^[j]^[k]);
                  irow:=j;
                  icol:=k;
                  end
               else if ipiv^[k]>1 then begin Result:=False; Exit; end;
   ipiv^[icol]:=ipiv^[icol]+1;
   if irow<>icol then
      begin
      for l:=0 to n-1 do
         begin
         dum:=a^[irow]^[l];
         a^[irow]^[l]:=a^[icol]^[l];
         a^[icol]^[l]:=dum;
         end;
      for l:=0 to m-1 do
         begin
         dum:=b^[irow]^[l];
         b^[irow]^[l]:=b^[icol]^[l];
         b^[icol]^[l]:=dum;
         end;
      end;
   indxr^[i]:=irow;
   indxc^[i]:=icol;
   if abs(a[icol,icol])<1e-18 then begin Result:=False; Exit; end;
   pivinv:=1/a^[icol]^[icol];
   a^[icol]^[icol]:=1;
   for l:=0 to n-1 do a^[icol]^[l]:=a^[icol]^[l]*pivinv;
   for l:=0 to m-1 do b^[icol]^[l]:=b^[icol]^[l]*pivinv;
   for ll:=0 to n-1 do
      if ll<>icol then
         begin
         dum:=a^[ll]^[icol];
         a^[ll]^[icol]:=0;
         for l:=0 to n-1 do
            a^[ll]^[l]:=a^[ll]^[l]-a^[icol]^[l]*dum;
         for l:=0 to m-1 do
            b^[ll]^[l]:=b^[ll]^[l]-b^[icol]^[l]*dum;
         end;
   end;
for l:=n-1 downto 0 do
   if indxr^[l]<>indxc^[l] then
      for k:=0 to n-1 do
         begin
         dum:=a^[k]^[indxr^[l]];
         a^[k]^[indxr^[l]]:=a^[k]^[indxc^[l]];
         a^[k]^[indxc^[l]]:=dum;
         end;
Result:=True;
end;

end.
